<?php

$themename = "Night Royale";
$shortname = "Night Royale";

if ( function_exists('register_sidebar') )
register_sidebar(array('name'=>'sidebar-home',
'before_widget' => '<div class="widget">',
'after_widget' => '</div>',
'before_title' => '<h3 class="widgettitle">',
'after_title' => '</h3>',
));
register_sidebar(array('name'=>'sidebar-interior',
'before_widget' => '<div class="widget">',
'after_widget' => '</div>',
'before_title' => '<h3 class="widgettitle">',
'after_title' => '</h3>',
));

function wpguy_initial_cap($content){
 
    // Regular Expression, matches a single letter
    // * even if it's inside a link tag.
    $searchfor = '/>(<a [^>]+>)?([^<\s])/';
 
    // The string we're replacing the letter for
    $replacewith = '>$1<span class="drop">$2</span>';
 
    // Replace it, but just once (for the very first letter of the post)
    $content = preg_replace($searchfor, $replacewith, $content, 1);
 
    // Return the result
    return $content;
}
 
// Add this function to the WordPress hook
add_filter('the_content', 'wpguy_initial_cap');
add_filter('the_excerpt', 'wpguy_initial_cap');

/*   Adapated from Andy Staines' Paged Navigation plugin - http://stuff.yellowswordfish.com/paged-navigation/ */

define('PNSHOW', 10);

function paged_menu()
{
	if(!is_page()) 
	{
		if(is_single())
		{
			$npost = get_next_post(false);
			if ( $npost )
			{
				$title = apply_filters('the_title', $npost->post_title);
				$string = '<a href="'. get_permalink($npost->ID) .'">';
				echo 'Next Item: '.$string.$title.'</a><br />';
			}

			$ppost = get_previous_post(false);
			if ( $ppost )
			{
				$title = apply_filters('the_title', $ppost->post_title);
				$string = '<a href="'. get_permalink($ppost->ID) .'">';
				echo 'Previous item: '.$string.$title.'</a>';
			} 

			$title = 'Back to the Front Page';
			$string = '<a href="'. get_option('home') .'">';
			echo '<br />'.$string.$title.'</a>';
		} else {

			echo '<div class="pagenavigationbox">';
			$nav = pn_navigation();
			echo '</div>';
			
		}
	}
}

function pn_navigation()
{
	global $paged, $wp_query, $max_page;

	$nav = array();
	
	if ( !$max_page ) 
	{
		$max_page = $wp_query->max_num_pages;
	}
	if( !$paged ) 
	{
		$paged = 1;
	}

	$nav['next'] = pn_next($paged, $max_page);
	echo ('<span class="pagenavcurrent">'.$paged.'</span>');
	$nav['previous'] = pn_previous($paged, $max_page);
	
	return $nav;
}

function pn_next($paged, $max_page)
{
	$start = ($paged - PNSHOW);
	if($start < 1) $start = 1;
	$end = ($paged - 1);

	if($start > 1)
	{
		$out.= '<a class="pagelink" href="'.get_pagenum_link(1).'">1</a><span class="pagenav">...</span>';
	}

	if($end > 0)
	{	
		for($i = $start; $i <= $end; $i++)
		{
			$out.= '<a class="pagelink" href="'.get_pagenum_link($i).'">'.$i.'</a>';
		}
	} else {
		$end = 0;
	}

	echo ($out);
	return $end;
}		

function pn_previous($paged, $max_page)
{
	$start = ($paged + 1);
	$end = ($paged + PNSHOW);
	if($end > $max_page) $end = $max_page;

	if($start <= $max_page)
	{
		for($i = $start; $i <= $end; $i++)
		{
			$out.= '<a class="pagelink" href="'.get_pagenum_link($i).'">'.$i.'</a>';
		}
		if($end < $max_page)
		{
			$out.= '<span class="pagenav">...</span><a class="pagelink" href="'.get_pagenum_link($max_page).'">'.$max_page.'</a>';
		}
	} else {
		$start = 0;
	}
			
	echo ($out);
	return $start;
}


//create options page
function nightRoyale() {
   if (function_exists('add_theme_page')) {
		add_theme_page('', 'Royale Settings', 8, basename(__FILE__), 'nightRoyalePage');
    }
}

function nightRoyalePage() {
  if (isset($_POST['info_update'])) { ?>
		<div id="message" class="updated fade">
		<p><strong>
<?php
	if($_POST['style_switch']){
		update_option('style_switch', $_POST['style_switch']);
	}else{
		update_option('style_switch', 'style');
	}
	if($_POST['v_flickr']){
       update_option('v_flickr', $_POST['v_flickr']);
    }else{
       update_option('v_flickr', '');
    }
    if($_POST['v_facebook']){
       update_option('v_facebook', $_POST['v_facebook']);
    }else{
       update_option('v_facebook', '');
    }
    if($_POST['v_twitter']){
       update_option('v_twitter', $_POST['v_twitter']);
    }else{
       update_option('v_twitter', '');
    }
    if($_POST['v_friendfeed']){
       update_option('v_friendfeed', $_POST['v_friendfeed']);
    }else{
       update_option('v_friendfeed', '');
    }
    if($_POST['v_friendster']){
       update_option('v_friendster', $_POST['v_friendster']);
    }else{
       update_option('v_friendster', '');
    }
   	if($_POST['v_lastfm']){
       update_option('v_lastfm', $_POST['v_lastfm']);
    }else{
       update_option('v_lastfm', '');
    }
    if($_POST['v_linkedin_first']){
       update_option('v_linkedin_first', $_POST['v_linkedin_first']);
    }else{
       update_option('v_linkedin_first', '');
    }
    if($_POST['v_linkedin_last']){
       update_option('v_linkedin_last', $_POST['v_linkedin_last']);
    }else{
       update_option('v_linkedin_last', '');
    }
    if($_POST['v_livejournal']){
       update_option('v_livejournal', $_POST['v_livejournal']);
    }else{
       update_option('v_livejournal', '');
    }
    if($_POST['v_mixx']){
       update_option('v_mixx', $_POST['v_mixx']);
    }else{
       update_option('v_mixx', '');
    }
    
    
    if($_POST['contact_email']){
       update_option('contact_email', $_POST['contact_email']);
    }else{
       update_option('contact_email', '');
    }
    if($_POST['contact_subject']){
       update_option('contact_subject', $_POST['contact_subject']);
    }else{
       update_option('contact_subject', '');
    }
    if($_POST['contact_success']){
       update_option('contact_success', $_POST['contact_success']);
    }else{
       update_option('contact_success', '');
    }	
?>
			OPTIONS UPDATED
        </strong></p>
        </div>
<?php } ?>

  	<div class="wrap">
	<form method="post">
    <h2>Royale Settings</h2>
    <table class="form-table" style="margin:0; width:auto">
    <tr>
    	<td><label for="style_switch"><h3>Style:</h3></label></td>
    	<td>
    		<select id="style_switch" name="style_switch">
    			<option selected="selected" value="<?=get_option('style_switch'); ?>">Current: <?=get_option('style_switch'); ?></option>
    			<option value="style">Default (purple)</option>
    			<option value="style_fire">Fire</option>
    			<option value="style_blue_smoke">Smoke (blue)</option>
    			<option value="style_vista_blue">Vista (blue)</option>
    		</select>
    	</td>
    </tr>
    </table>
	<h2>Social Media Links</h2>
	<table class="form-table" style="margin:0; width:auto">
	<tr>
		<td><label for="v_flickr"><h3>Flickr:</h3></label></td>
		<td><input type="text" name="v_flickr" id="v_flickr" maxlength="60" size="25" value="<?php echo get_option('v_flickr'); ?>" /></td>
		<td>Enter your <strong>Flickr Username</strong>.</td>
	</tr>
	<tr>
		<td><label for="v_facebook"><h3>Facebook:</h3></label></td>
		<td><input type="text" name="v_facebook" id="v_facebook" maxlength="60" size="25" value="<?php echo get_option('v_facebook'); ?>" /></td>
		<td>Enter your <strong>Facebook Public Address</strong>. You can find this by searching on google for your name plus facebook and copy the full address into the input box. <em>Example: http://www.facebook.com/people/Clay-McIlrath/40006440</em></em></td>
	</tr>
	<tr>
		<td><label for="v_twitter"><h3>Twitter:</h3></label></td>
		<td><input type="text" name="v_twitter" id="v_twitter" maxlength="60" size="25" value="<?php echo get_option('v_twitter'); ?>" /></td>
		<td>Enter your <strong>Twitter Username</strong></td>
	</tr>
	<tr>
		<td><label for="v_friendfeed"><h3>Friendfeed:</h3></label></td>
		<td><input type="text" name="v_friendfeed" id="v_friendfeed" maxlength="60" size="25" value="<?php echo get_option('v_friendfeed'); ?>" /></td>
		<td>Enter your <strong>Friendfeed Username</strong></td>
	</tr>
	<tr>
		<td><label for="v_friendster"><h3>Friendster:</h3></label></td>
		<td><input type="text" name="v_friendster" id="v_friendster" maxlength="60" size="25" value="<?php echo get_option('v_friendster'); ?>" /></td>
		<td>Enter your <strong>Friendster ID</strong>. You can find this by viewing your profile and copying the number at the end of the url. <em>Example: http://profiles.friendster.com/<strong>80786101</strong></em></td>
	</tr>
	<tr>
		<td><label for="v_lastfm"><h3>Last.fm:</h3></label></td>
		<td><input type="text" name="v_lastfm" id="v_lastfm" maxlength="60" size="25" value="<?php echo get_option('v_lastfm'); ?>" /></td>
		<td>Enter your <strong>Last.fm Username</strong></td>
	</tr>
	<tr>
		<td><h3>LinkedIn:</h3></td>
		<td>
			<label for="v_linkedin_first">First Name:</label><br />
			<input type="text" name="v_linkedin_first" id="v_linkedin_first" maxlength="60" size="25" value="<?php echo get_option('v_linkedin_first'); ?>" />
		</td>
		<td>
			<label for="v_linkedin_last">Last Name:</label><br />
			<input type="text" name="v_linkedin_last" id="v_linkedin_last" maxlength="60" size="25" value="<?php echo get_option('v_linkedin_last'); ?>" />
		</td>
	</tr>
	<tr>
		<td><label for="v_livejournal"><h3>Live&nbsp;Journal:</h3></label></td>
		<td><input type="text" name="v_livejournal" id="v_livejournal" maxlength="60" size="25" value="<?php echo get_option('v_livejournal'); ?>" /></td>
		<td>Enter your <strong>Live Journal Username</strong></td>
	</tr>
	<tr>
		<td><label for="v_mixx"><h3>Mixx:</h3></label></td>
		<td><input type="text" name="v_mixx" id="v_mixx" maxlength="60" size="25" value="<?php echo get_option('v_mixx'); ?>" /></td>
		<td>Enter your <strong>Mixx Username</strong></td>
	</tr>
	</table>
	
	<h3>Contact Form Settings</h3>
	<table class="form-table">
	<tr>
		<td><label for="contact_email">Your email address:</label></td>
		<td><input type="text" name="contact_email" id="contact_email" size="60" value="<?php echo get_option('contact_email'); ?>" /></td>
	</tr>
	<tr>
		<td><label for="contact_subject">Contact email subject:</label></td>
		<td><input type="text" name="contact_subject" id="contact_subject" size="60" value="<?php echo get_option('contact_subject'); ?>" /></td>
	</tr>
	<tr>
		<td><label for="contact_success">Contact success message:</label></td>
		<td><input type="text" name="contact_success" id="contact_success" size="60" value="<?php echo get_option('contact_success'); ?>" /></td>
	</tr>
	</table>

     <div class="submit"><input type="submit" name="info_update" value="<?php _e('Update Options', 'English'); ?> &raquo;" /></div>
</form>
</div>

<?php   
}

//set initial defaults for feeds
add_option('v_flickr', '');
add_option('v_facebook', '');
add_option('v_twitter', '');
add_option('v_friendfeed', '');
add_option('v_friendster', '');
add_option('v_lastfm', '');
add_option('v_linkedin_first', '');
add_option('v_linkedin_last', '');
add_option('v_livejournal', '');
add_option('v_mixx', '');

add_option('contact_email', '');
add_option('contact_subject', '');
add_option('contact_success', '');
add_option('style_switch', '');

//add menu
add_action('admin_menu', 'nightRoyale');
	
?>
